/*
[A-Life]: Investigacin sobre Vida Artificial. El Algoritmo Evolutivo.

Autor: Rafael Alberto Moreno Parra. enginelife@hotmail.com
URL:   http://www.geocities.com/krousky
Fecha: 16 de Enero de 2001

Simulacin:  AlgEvo001
Herramienta: Microsoft Visual C++ 6.0

Objetivo:
Dado un Universo, este esta lleno de ambientes, hay una serie de
elementos (materia) que reaccionan al estado del ambiente, una serie
de seres vivos comandados por el "algoritmo evolutivo", buscan conseguir
dichos elementos usando estratgias como desplazamiento, coleccin de nuevos
elementos, etc...

*/

#include "Parametro.h"

/* Esta clase representa la materia y energa del Universo */
class Material
{
public:
	/* Identificador de material */
	unsigned int m_iIDmat;

	/* Es un material nodal */
	unsigned int m_iPosX, m_iPosY;

	/* Como se comporta en el ambiente donde se encuentra en f(z) */
	char m_sEcuacion[MAT_LONGEXPR];

	/* Chequea si esta siendo usado por algn organismo */
	unsigned int m_iUsado;

	/* Inicializa */
	void vInicia(unsigned int iID, unsigned int iXmin, unsigned int iYmin, unsigned int iXmax, unsigned int iYmax);

	/* Retorna valor positivo o negativo de energa */
	signed int iEnergia(float fValAmbiente);
};
